// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2022 Florian Schmaus
#include <iostream>

#include "BinaryPrivateSemaphore.hpp"
#include "Fibril.hpp"

// NOLINTNEXTLINE(clang-diagnostic-unknown-attributes)
emper_fibril static void waitOnBps(BPS* bps) { bps->wait(); }

// NOLINTNEXTLINE(clang-diagnostic-unknown-attributes)
emper_fibril static void spawnFirstThenSignal() {
	Fibril fibril;
	BPS bps;

	fibril.spawn(waitOnBps, &bps);

	bps.signal();

	fibril.sync();
}

// NOLINTNEXTLINE(clang-diagnostic-unknown-attributes)
emper_fibril static void signalFirstThenSpawn() {
	Fibril fibril;
	BPS bps;

	bps.signal();

	fibril.spawn(waitOnBps, &bps);

	fibril.sync();
}

void emperTest() {
	std::cout << "####    Spawn first, then signal\n";
	spawnFirstThenSignal();

	std::cout << "####    Signal first, then spawn\n";
	signalFirstThenSpawn();

	std::cout << "####    Return from emperTest()\n";
}
