// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Fischer
#include <array>
#include <cstdlib>

#include "Emper.hpp"
#include "emper-config.h"	 // for EMPER_IO_WORKER_URING_ENTRIES
#include "io/Future.hpp"	 // for AlarmFuture

using emper::io::AlarmFuture;

void emperTest() {
	if constexpr (emper::IO_SYNCHRONOUS) exit(77);

	const size_t links = static_cast<size_t>(EMPER_IO_WORKER_URING_ENTRIES) * 2;
	std::array<AlarmFuture*, links> futures;
	AlarmFuture::Timespec ts = {.tv_sec = 0, .tv_nsec = 100};

	for (unsigned i = 0; i < links; ++i) {
		auto* future = new AlarmFuture(ts);
		if (i > 0) {
			future->setDependency(*futures[i - 1]);
		}

		futures[i] = future;
	}

	futures[links - 1]->submitAndWait();
}
